<?php
/**
 * @package WordPress
 * @subpackage acoda  */ 
?>
<!DOCTYPE html>
<!--[if lt IE 7]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="en"> <![endif]-->
<!--[if IE 7]>    <html class="no-js lt-ie9 lt-ie8" lang="en"> <![endif]-->
<!--[if IE 8]>    <html class="no-js lt-ie9" lang="en"> <![endif]-->
<!--[if gt IE 8]><!--> <html <?php language_attributes(); ?>> <!--<![endif]-->
<head>

<meta charset="<?php bloginfo( 'charset' ); ?>" />

	<?php 

	echo '<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">';
	
	echo '<link rel="pingback" href="'. esc_url( get_bloginfo('pingback_url') ) .'" />';		
	
	wp_head(); ?>
           
</head>
<body <?php body_class(); ?> >

	<?php	
	
	// Get Post ID
	if( is_archive() )
	{
		$url = explode('?', 'http://'. $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"] );
		$post_id = ( isset( $_GET['page_id'] ) ? esc_attr( $_GET['page_id'] ) : url_to_postid( esc_url( $url[0] ) ) );			
	}
	else
	{
		$post_id = ( !empty( $post ) && ! is_search() ? $post->ID : '' );
	}

	$header_float 			= ( get_post_meta( $post_id, '_'. ACODA_THEME_PREFIX .'_header_float', true )	!= ''	? get_post_meta( $post_id, '_'. ACODA_THEME_PREFIX .'_header_float', true ) : ( of_get_option('header_float')	!= '' ? of_get_option('header_float')	: '' ) ); 	
	$site_layout 			= ( get_post_meta( $post_id, '_'. ACODA_THEME_PREFIX .'_site_layout', true )		!= ''	? get_post_meta( $post_id, '_'. ACODA_THEME_PREFIX .'_site_layout', true ) : ( of_get_option('site_layout') != '' ? of_get_option('site_layout') : 'wide' ) );
	$single_static_header	= ( get_post_meta( $post_id, '_'. ACODA_THEME_PREFIX .'_single_static_header', true ) != 'disable'	? 'single_static_header ' : '' ); 
	$anchorlink_nav	 	= ( get_post_meta( $post_id, '_'. ACODA_THEME_PREFIX .'_anchorlink_nav', true ) == 'enable' ) 	? 'anchorlink-nav ' : '';
	$directional_nav	 	= ( get_post_meta( $post_id, '_'. ACODA_THEME_PREFIX .'_directional_nav', true ) != '' ?  get_post_meta( $post_id, '_'. ACODA_THEME_PREFIX .'_directional_nav', true ). ' ' : 'dir-nav-icon ' );
	$animate_type 			= ( of_get_option('animate_type' ) != '' ? ' '. of_get_option('animate_type' ) : ' animate-3d' );
	
	$page_animate_headerfooter	= '';
	
	$acoda_layout 			= acoda_global_vars('page_layout');
	$page_animate_type 	= acoda_global_vars('page_animate_type');
	$acoda_sticky_menu 	= acoda_global_vars('sticky_menu');	
	
	if( 'disable' === $directional_nav )
	{
		$directional_nav = 'dir-nav-icon-disabled ';
	}

	// Single Page Animate
	if( !empty( $page_animate_type ) )
	{
		// Set header to float is page animate is enabled
		if( empty( $header_float  ) )
		{
			$header_float = 'header_float';	
		}
		
		$page_animate_headerfooter = 'animate_headerfooter ';
	}
	
	do_action('acoda_before_primary_wrapper');

	echo "\n". '<div id="primary-wrapper" class="'. ( !empty( $site_layout ) ? 'layout-'. esc_attr( $site_layout ) : ''  ) .' page_'. esc_attr( $acoda_layout .' '. $header_float .' '. $anchorlink_nav . $directional_nav . $page_animate_type . $single_static_header . $page_animate_headerfooter . $animate_type ) . ( $acoda_sticky_menu != 'disable' && of_get_option( 'header_display' ) != 'disable' ? ' sticky-header' : '' ) .'">';
	echo "\n". '<div class="site-inwrap clearfix">';
	echo "\n". '<a id="top"></a>';

	
	do_action('acoda_before_main_wrap');

	
	echo "\n". '<div id="main-wrap">';
	echo "\n\t". '<div class="main-wrap skinset-main acoda-skin clearfix '. esc_attr( $header_float ) .'">';		

	do_action('acoda_before_content_wrap');
	
	echo "\n" . '<div class="content-wrap row">';