<?php
/**
 * ACODA shortcode includes
 *
 * @package ACODA
 *
 */
 
/* ------------------------------------
:: VISUAL COMPOSER
------------------------------------ */
	
	if ( class_exists('WPBakeryVisualComposerAbstract') )
	{		
		update_option( 'wpb_js_row_css_class', 'row' );
		update_option( 'wpb_js_column_css_classes', '' );
	
		/* ------------------------------------
		:: SHORTCODE OPTIONS FUNCTION
		------------------------------------*/
	
		function acoda_options_array( $type )
		{
			if( $type == 'animation' )
			{
				return $animation_types = array("fade","fadeZoom","cover","scrollHorz","scrollVert","shuffle","toss");	
			}
	
			if( $type == 'datasource' )
			{
				$datasource = array(
					esc_html__( 'Select Source', 'you' ) => "", 
					esc_html__( 'Image Selector', 'you' ) => "data-9", 
					//esc_html__( 'Slide Sets', 'you' ) => "data-4",
					esc_html__( 'Build Query', 'you' ) => "data-10", 
				);						
						
				return $datasource;
			}
			
			if( $type == 'imageeffect' )
			{
				return $image_effect = array(
					esc_html__( 'None', 'you' ) => "",
					esc_html__( 'Frame', 'you' ) => "frame",
					esc_html__( 'Round', 'you' ) => "round",
					esc_html__( 'Frame + Round', 'you' ) => "frame round",
					esc_html__( 'Black & White', 'you' ) => 'blackwhite',
				);	
			}
		}
		
	
		/* ------------------------------------
		:: SHORTCODE GALLERY OPTIONS FUNCTION
		------------------------------------*/	
		
		function acoda_common_options( $type, $object ='', $option = null )
		{	
			$extras = '';
			
			if( $type == 'datasource' )
			{
				$option = array(
					"type" => "dropdown",
					"class" => "",
					"heading" => esc_html__("Select Image / Media Source", 'you'),
					"param_name" => "data_source",
					"value" => acoda_options_array( 'datasource' )
				);
			}
			elseif( $type == 'data-9' )
			{
				$option = array(
					"type" => "attach_images",
					"heading" => esc_html__("Images", 'you'),
					"param_name" => "images_attach",
					"value" => "",
					"description" => esc_html__("Select images from media library.", 'you'),
					"dependency" => Array('element' => 'data_source' /*, 'not_empty' => true*/, 'value' => array('data-9'))
      			);
			}	
			elseif( $type == 'data-10' )
			{			
				$option = array(
					"type" => "loop",
					"heading" => esc_html__("Grids content", 'you'),
					"param_name" => "loop",
					'settings' => array(
						'size' => array('hidden' => false, 'value' => 10),
						'order_by' => array('value' => 'date'),
					),
					"description" => esc_html__("Create WordPress loop, to populate content from your site.", 'you'),
					"dependency" => Array('element' => 'data_source' /*, 'not_empty' => true*/, 'value' => array('data-10'))
				);
			}
			elseif( $type == 'orderby' )
			{
				if( $object == 'recentposts' )
				{
					$option = array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__( 'Order Post By', 'you'),
						"param_name" => "orderby",
						"value" => array(
							esc_html__( 'Ascending', 'you') => 'ASC',
							esc_html__( 'Descending', 'you') => 'DESC'
						)
					);				
				}
				else
				{
					$option = array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__( 'Order Post By', 'you'),
						"param_name" => "orderby",
						"dependency" => Array('element' => 'data_source' /*, 'not_empty' => true*/, 'value' => array('data-2','data-1','data-8','data-6','data-5')),
						"value" => array(
							esc_html__( 'Ascending', 'you') => 'ASC',
							esc_html__( 'Descending', 'you') => 'DESC'
						)
					);				
				}
	
			}
			elseif( $type == 'sortby' || $type == 'order' )
			{
				if( $object == 'recentposts' )
				{
					$option = array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__( 'Sort Post By', 'you'),
						"param_name" => $type,
						"value" => array(
							esc_html__( 'Post Order', 'you') => '',
							esc_html__( 'Date', 'you') => 'date',
							esc_html__( 'Random', 'you') => 'rand',
							esc_html__( 'Title', 'you') => 'title',
						)
					);				
				}
				else
				{
					$option = array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Sort Post By", 'you'),
						"param_name" => $type,
						"dependency" => Array('element' => 'data_source' /*, 'not_empty' => true*/, 'value' => array('data-2','data-1','data-8','data-6','data-5')),
						"value" => array(
							esc_html__( 'Post Order', 'you') => '',
							esc_html__( 'Date', 'you') => 'date',
							esc_html__( 'Random', 'you') => 'rand',
							esc_html__( 'Title', 'you') => 'title',
						)
					);
				}
			}				
			elseif( $type == 'data-4' )
			{
				$option = array(
					"type" => "checkbox",
					"class" => "",
					"heading" => esc_html__("Slide Sets", 'you'),
					"param_name" => "slidesetid",
					"dependency" => Array('element' => 'data_source' /*, 'not_empty' => true*/, 'value' => array('data-4')),
					"value" => acoda_data_source( 'data-4', 'shortcode' )
				);
			}	
			elseif( $type == 'width' )
			{
				$option = array(
					"type" => "textfield",
					"class" => "",
					"heading" => esc_html__("Gallery Width", 'you'),
					"param_name" => "width",
				);
			}
			elseif( $type == 'height' )
			{
				if( $object == 'grid' )
				{
					$text = esc_html__( 'Row Height', 'you');	
				}
				else
				{
					$text = esc_html__( 'Gallery Height', 'you');	
				}
				
				$option = array(
					"type" => "textfield",
					"class" => "",
					"heading" => $text,
					"param_name" => "height",
				);
			}
			elseif( $type == 'columns' )
			{
				$option = array(
					"type" => "dropdown",
					"class" => "",
					"heading" => esc_html__("Columns", 'you'),
					"param_name" => "columns",
					"value" => array(
						esc_html__( '3 Columns', 'you') => '',
						esc_html__( '1 Columns', 'you') => '1',
						esc_html__( '2 Columns', 'you') => '2',
						esc_html__( '4 Columns', 'you') => '4',
						esc_html__( '5 Columns', 'you') => '5',
						esc_html__( '6 Columns', 'you') => '6',
					)
				);
			}
			elseif( $type == 'columnpadding' )
			{
				$option = array(
					"type" => "checkbox",
					"class" => "",
					"heading" => esc_html__( 'Column Padding', 'you' ),
					"param_name" => "columnpadding",
					"value" => array(
						esc_html__( 'Enable', 'you') => 'column_padding'
					)
				);
			}		
			elseif( $type == 'content' )
			{	
				$option = array(
					"type" => "dropdown",
					"class" => "",
					"heading" => esc_html__( 'Content', 'you'),
					"param_name" => "content_type",
					"value" => array(
						esc_html__( 'Text on Hover + Image', 'you') => 'titletextoverlay',
						esc_html__( 'Title on Hover + Image', 'you') => 'titleoverlay',					
						esc_html__( 'Text + Image', 'you') => 'textimage',
						esc_html__( 'Title + Image', 'you') => 'titleimage',
						esc_html__( 'Image', 'you') => 'image',
					)
				);
	
				if( $object == 'recent_posts' )
				{
					$option['value']['Title'] = 'title';
				}
				
			}		
			elseif( $type == 'align' || $type == 'position' )
			{
	
				if( $object !='' )
				{
					$text = $object;	
				}
				
				
				$option = array(
					"type" => "dropdown",
					"class" => "",
					"heading" => sprintf( esc_html__('%s Align', 'you' ), $text ),
					"param_name" => $type,
					"value" => array(
						esc_html__('Normal', 'you' ) => '',
						esc_html__('Left', 'you' ) => 'alignleft',
						esc_html__('Center', 'you' ) => 'aligncenter',
						esc_html__('Right', 'you' ) => 'alignright'
					)
				);
			}			
			elseif( $type == 'imgwidth' )
			{
				$option = array(
					"type" => "textfield",
					"class" => "",
					"heading" => esc_html__("Image Width", 'you'),
					"param_name" => "imgwidth",
				);
			}	
			elseif( $type == 'imgheight' )
			{
				$option = array(
					"type" => "textfield",
					"class" => "",
					"heading" => esc_html__("Image Height", 'you'),
					"param_name" => "imgheight",
				);
			}
			elseif( $type == 'imageeffect' )
			{
				$option = array(
					"type" => "dropdown",
					"class" => "",
					"heading" => esc_html__("Image Effect", 'you'),
					"param_name" => "imageeffect",
					"value" => acoda_options_array( 'imageeffect' )
				);
			}
			elseif( $type == 'timeout' )
			{
				$option = array(
					"type" => "textfield",
					"class" => "",
					"heading" => esc_html__("Timeout", 'you'),
					"param_name" => "timeout",
					"description" => esc_html__("Time between animating slides, in seconds.", 'you')
				);
			}												
			
			if( empty( $option ) )
			{
				$option = array(
					"type" => NULL,
					"param_name" => NULL,
					"value" => NULL
				);
			}
			
			return $option;
		}

		$add_css_animation = array(
			"type" => "dropdown",
			"heading" => esc_html__("CSS Animation", 'you'),
			"param_name" => "css_animation",
			"admin_label" => true,
			"value" => array(
				esc_html__("No", 'you') => '', 
				esc_html__("Top to bottom", 'you') => "top-to-bottom", 
				esc_html__("Bottom to top", 'you') => "bottom-to-top", 
				esc_html__("Left to right", 'you') => "left-to-right", 
				esc_html__("Right to left", 'you') => "right-to-left", 
				esc_html__("Appear from center", 'you') => "appear",
				esc_html__("Rotate Top to Bottom", 'you') => "rotate-top-to-bottom",
				esc_html__("Rotate Bottom to Top", 'you') => "rotate-bottom-to-top",
				esc_html__("Rotate Left to Right", 'you') => "rotate-left-to-right",
				esc_html__("Rotate Right to Left", 'you') => "rotate-right-to-left",
				esc_html__("Pulse", 'you') => "pulse",
				esc_html__("Swing", 'you') => "swing",
				esc_html__("Slide Left to Right", 'you') => "slide-left-to-right",
				
			),
			"description" => esc_html__("Select type of animation if you want this element to be animated when it enters into the browsers viewport. Note: Works only in modern browsers.", 'you')
		);	

		$box_styles = array(
			esc_html__( 'Default', 'you' ) => '',
			esc_html__( 'Rounded', 'you' ) => 'vc_box_rounded',
			esc_html__( 'Border', 'you' ) => 'vc_box_border',
			esc_html__( 'Outline', 'you' ) => 'vc_box_outline',
			esc_html__( 'Shadow', 'you' ) => 'vc_box_shadow',
			esc_html__( 'Bordered shadow', 'you' ) => 'vc_box_shadow_border',
			esc_html__( '3D Shadow', 'you' ) => 'vc_box_shadow_3d'
		);


		$round_box_styles = array(
			esc_html__( 'Round', 'you' ) => 'vc_box_circle',
			esc_html__( 'Round Border', 'you' ) => 'vc_box_border_circle',
			esc_html__( 'Round Outline', 'you' ) => 'vc_box_outline_circle',
			esc_html__( 'Round Shadow', 'you' ) => 'vc_box_shadow_circle',
			esc_html__( 'Round Border Shadow', 'you' ) => 'vc_box_shadow_border_circle'
		);


		$circle_box_styles = array(
			esc_html__( 'Circle', 'you' ) => 'vc_box_circle_2',
			esc_html__( 'Circle Border', 'you' ) => 'vc_box_border_circle_2',
			esc_html__( 'Circle Outline', 'you' ) => 'vc_box_outline_circle_2',
			esc_html__( 'Circle Shadow', 'you' ) => 'vc_box_shadow_circle_2',
			esc_html__( 'Circle Border Shadow', 'you' ) => 'vc_box_shadow_border_circle_2'
		);	
		
		$all_box_styles = array_merge( $box_styles, $round_box_styles, $circle_box_styles );			

		$size_arr = array(
			esc_html__( 'Regular size', 'you' ) => 'wpb_regularsize',
			esc_html__( 'Large', 'you' ) => 'btn-large',
			esc_html__( 'Small', 'you' ) => 'btn-small',
			esc_html__( 'Mini', 'you' ) => "btn-mini"
		);	

		$el_widths = array(
			'100%' => '',
			'90%' => '90',
			'80%' => '80',
			'70%' => '70',
			'60%' => '60',
			'50%' => '50',
			'40%' => '40',
			'30%' => '30',
			'20%' => '20',
			'10%' => '10',
			'5%' => '5'
		);	

		$border_widths = array(
			'1px' => '1px',
			'2px' => '2px',
			'3px' => '3px',
			'4px' => '4px',
			'5px' => '5px',
			'6px' => '6px',
			'7px' => '7px',
			'8px' => '8px',
			'9px' => '9px',
			'10px' => '10px'
		);				

		$target_arr = array(
			esc_html__( 'Same window', 'you' ) => '_self',
			esc_html__( 'New window', 'you' ) => "_blank"
		);		

	
		/* ------------------------------------
		:: SHORTCODES + MAPS
		------------------------------------*/
	
		require_once( get_template_directory() . '/lib/inc/shortcodes/grid-gallery.php' );
		require_once( get_template_directory() . '/lib/inc/shortcodes/group-slider.php' );
		require_once( get_template_directory() . '/lib/inc/shortcodes/stage-slider.php' );
		require_once( get_template_directory() . '/lib/inc/shortcodes/carousel-slider.php' );
		require_once( get_template_directory() . '/lib/inc/shortcodes/lists.php' );
		require_once( get_template_directory() . '/lib/inc/shortcodes/social-icons.php' );
		require_once( get_template_directory() . '/lib/inc/shortcodes/text-slider.php' );
		require_once( get_template_directory() . '/lib/inc/shortcodes/row-shapes.php' );
	
		add_filter('widget_text', 'do_shortcode');
		
	
		/* ------------------------------------
		:: EXTRA PARAMS
		------------------------------------*/	
			
		// Progress Bar
		vc_add_param('vc_progress_bar',
			array(
				"type" => "colorpicker",
				"heading" => esc_html__( 'Text Color', 'you' ),
				"param_name" => "textcolor",
				"value" => "",
				"dependency" => Array('element' => 'bgcolor' /*, 'not_empty' => true*/, 'value' => array('custom')),
			)
		);	

		// Video
		vc_add_param('vc_video',
			array(
				"type" => "dropdown",
				"heading" => esc_html__("Embed Type", 'you'),
				"param_name" => "type",
				"value" => array(
					'oEmbed ' => "oembed", 
					'YouTube' => "youtube", 
					'Vimeo' => "vimeo", 																																											
					'JW Player' => "jwp", 
					'Wistia' => "wistia", 
				),
			)	
		);

		vc_add_param('vc_video',
			array(
				"type" => "dropdown",
				"heading" => esc_html__("Ratio", 'you'),
				"param_name" => "ratio",
				"value" => array(
					'16:9' => "", 
					'4:3' => "four_by_three", 
					esc_html__( 'Normal', 'you' ) => "normal", 																																											
				),
			)	
		);

		vc_add_param('vc_video',
			array(
				"type" => "dropdown",
				"heading" => esc_html__("Style", 'you'),
				"param_name" => "style",
				"value" => array(
					esc_html__( 'Normal', 'you' ) => "", 
					esc_html__( 'Frame', 'you' ) => "frame", 																																											
				),
			)	
		);		

		vc_add_param('vc_video',
			array(
				"type" => "checkbox",
				"class" => "",
				"heading" => esc_html__("Autoplay", 'you'),
				"param_name" => "autoplay",
				"dependency" => Array('element' => 'type' /*, 'not_empty' => true*/, 'value' => array( 'youtube','vimeo','jwp','wistia') ),
				"value" => array(
					'Enable' => '1',
				),
			)	
		);					
		
		vc_add_param( 'vc_column_text', $add_css_animation );
		vc_add_param( 'vc_btn', $add_css_animation );
		vc_add_param( 'vc_message', $add_css_animation );
		vc_add_param( 'vc_icon', $add_css_animation );

		add_action( 'vc_after_init', 'acoda_add_options' ); /* Note: here we are using vc_after_init because WPBMap::GetParam and mutateParame are available only when default content elements are "mapped" into the system */
		
		function acoda_add_options()
		{
			$param = WPBMap::getParam( 'vc_btn', 'color' );
			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Default', 'you' )] = 'link_color';
				$param['std'] = 'link_color';
			}

			vc_update_shortcode_param( 'vc_btn', $param );
	
			$param = WPBMap::getParam( 'vc_icon', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Default', 'you' )] = 'link_color';
				$param['std'] = 'link_color';
			}
			  
			vc_update_shortcode_param( 'vc_icon', $param );
	
			$param = WPBMap::getParam( 'vc_icon', 'background_color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Default', 'you' )] = 'skin_element';
				$param['std'] = 'skin_element';
			}
			  
			vc_update_shortcode_param( 'vc_icon', $param );	

			$param = WPBMap::getParam( 'vc_icon', 'align' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Inline', 'you' )] = 'inline';
				$param['std'] = 'inline';
			}
			  
			vc_update_shortcode_param( 'vc_icon', $param );			

			$param = WPBMap::getParam( 'vc_cta', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Default', 'you' )] = 'skin_element';
				$param['std'] = 'skin_element';
			}
			  
			vc_update_shortcode_param( 'vc_cta', $param );		
			

			$param = WPBMap::getParam( 'vc_separator', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Default', 'you' )] = '';
				$param['value'][esc_html__( 'Skin Link Color', 'you' )] = 'link_color';
				$param['std'] = '';
			}
			  
			vc_update_shortcode_param( 'vc_separator', $param );	

			$param = WPBMap::getParam( 'vc_tta_tabs', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Button Color', 'you' )] = 'button_color';
				$param['value'][esc_html__( 'Skin Shaded Color', 'you' )] = 'shaded_color';
				$param['std'] = 'button_color';
			}
			  
			vc_update_shortcode_param( 'vc_tta_tabs', $param );	

			$param = WPBMap::getParam( 'vc_tta_accordion', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Button Color', 'you' )] = 'button_color';
				$param['value'][esc_html__( 'Skin Shaded Color', 'you' )] = 'shaded_color';
				$param['std'] = 'shaded_color';
			}
			  
			vc_update_shortcode_param( 'vc_tta_accordion', $param );	
			
			$param = WPBMap::getParam( 'vc_message', 'message_box_color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Button Color', 'you' )] = 'button_color';
				$param['value'][esc_html__( 'Skin Shaded Color', 'you' )] = 'shaded_color';
				$param['std'] = 'shaded_color';
			}
			  
			vc_update_shortcode_param( 'vc_message', $param );						

			$param = WPBMap::getParam( 'vc_toggle', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Button Color', 'you' )] = 'button_color';
				$param['std'] = 'button_color';
			}
			  
			vc_update_shortcode_param( 'vc_toggle', $param );					

			$param = WPBMap::getParam( 'vc_tta_tour', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Button Color', 'you' )] = 'button_color';
				$param['value'][esc_html__( 'Skin Shaded Color', 'you' )] = 'shaded_color';
				$param['std'] = 'button_color';
			}
			  
			vc_update_shortcode_param( 'vc_tta_tour', $param );					
	

			$param = WPBMap::getParam( 'vc_btn', 'style' );

			if( isset( $param['value'] ) )
			{
				$param['value'][esc_html__( 'Text Only', 'you' )] = 'outline text_only';
			}
			  
			vc_update_shortcode_param( 'vc_btn', $param );	

			$param = WPBMap::getParam( 'vc_btn', 'size' );

			if( isset( $param['value'] ) )
			{
				$param['value'][esc_html__( 'Extra Large', 'you' )] = 'xlg';
				$param['value'][esc_html__( 'Super Size', 'you' )] = 'sup';
			}
			  
			vc_update_shortcode_param( 'vc_btn', $param );													
		}			
		
		$allowed_tags = wp_kses_allowed_html();
	
		// VC Row
		vc_map( array(
		  "name" => esc_html__("Row", 'you'),
		  "base" => "vc_row",
		  "is_container" => true,
		  "icon" => "icon-wpb-row",
		  "show_settings_on_create" => false,
		  "category" => esc_html__('Content', 'you'),
		  "params" => array(	
			array(
				'type' => 'dropdown',
				'heading' => esc_html__( 'Row Stretch', 'you' ),
				'param_name' => 'full_width',
				'value' => array(
					esc_html__('Default','you') => '',
					esc_html__('Stretch row','you') => 'stretch_row',
					esc_html__('Stretch row and content','you') => 'stretch_row_content',
					esc_html__('Stretch row and content without spaces','you') => 'stretch_row_content_no_spaces',
				),
				'description' => esc_html__( 'Select stretching options for row and content. Stretched row overlay sidebar and may not work if parent container has overflow: hidden css property.', 'you' )
			),
			array(
				'type' => 'dropdown',
				'heading' => esc_html__( 'Row Height', 'you' ),
				'param_name' => 'full_height',
				'value' => array(
					esc_html__('Default','you') => '',
					esc_html__('25%','you') => 'onequarter_row_height',
					esc_html__('50%','you') => 'half_row_height',
					esc_html__('75%','you') => 'threequarter_row_height',
					esc_html__('100%','you') => 'full_row_height',					
				),
				'description' => esc_html__( 'Set the minimum height of the row. Size is based on Browser window size.', 'you' )
			),		
			array(
				'type' => 'dropdown',
				'heading' => esc_html__( 'Content position', 'you' ),
				'param_name' => 'content_placement',
				'value' => array(
					esc_html__( 'Middle', 'you' ) => 'middle',
					esc_html__( 'Top', 'you' ) => 'top',
					esc_html__( 'Bottom', 'you' ) => 'bottom',
				),
				'description' => wp_kses( __( 'Select content position within <strong>Full Height</strong> row.', 'you' ), $allowed_tags ),
			),			
			array(
				"type" => "checkbox",
				"class" => "",
				"heading" => esc_html__("Equal Column Height", 'you'),
				"param_name" => "equal_height",
				"description" => esc_html__( 'If checked columns will be set to equal height.', 'you' ),
				"value" => array(
					esc_html__( 'Yes', 'you' ) => 'yes',
				),
			),										
			array(
			  "type" => "textfield",
			  "heading" => esc_html__("Anchor Link Name", 'you'),
			  "param_name" => "anchor_link",
			  "description" => esc_html__("Use this field to add an Anchor Name. You can then use links to scroll to this row, including from the menu.", 'you')
			),					  
			array(
			  "type" => "colorpicker",
			  "heading" => esc_html__('Font Color', 'you'),
			  "param_name" => "font_color",
			),		  
			array(
			  "type" => "textfield",
			  "heading" => esc_html__("Extra class name", 'you'),
			  "param_name" => "el_class",
			  "description" => wp_kses( __("<p>Use this field to add a class name and then refer to it in the Theme Options > Custom CSS field.", 'you'), $allowed_tags )
			),	
			array(
			  "type" => "css_editor",
			  "heading" => esc_html__('Css', 'you'),
			  "param_name" => "css",
			  // "description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'you'),
			  "group" => esc_html__('Design options', 'you')
			),			
			array(
				"type" => "dropdown",
				"class" => "",
				"heading" => esc_html__("Background Horizontal Position", 'you'),
				"param_name" => "h_position",
				"value" => array(
					'Center' => '',
					'Left' => 'left',
					'Right' => 'right',
				),
				"group" => esc_html__('Design options', 'you')
			),	
			array(
				"type" => "dropdown",
				"class" => "",
				"heading" => esc_html__("Background Vertical Position", 'you'),
				"param_name" => "v_position",
				"value" => array(
					'Center' => '',
					'Top' => 'top',
					'Bottom' => 'bottom',
				),
				"group" => esc_html__('Design options', 'you')
			),						  	
			array(
				"type" => "dropdown",
				"class" => "",
				"heading" => esc_html__("Parallax", 'you'),
				"param_name" => "parallax",
				"description" => wp_kses( __( 'Add Parallax effect to <strong>Background Image</strong>.', 'you' ), $allowed_tags ),
				"value" => array(
					'Disabled' => '',
					'Normal' => 'yes',
					'With Fade' => 'content-moving-fade',
				),
				"group" => esc_html__('Background Extras', 'you')
			),						
			array(
				"type" => "attach_images",
				"heading" => esc_html__("Slider Images", 'you'),
				"param_name" => "slider_images",
				"value" => "",
				"description" => esc_html__("Add a Slider to the row background.", 'you'),
				"group" => esc_html__('Background Extras', 'you')
      		),
			array(
				"type" => "dropdown",
				"class" => "",
				"heading" => esc_html__( 'Slider Effect', 'you'),
				"param_name" => "slider_animation",
				"value" => acoda_options_array( 'animation' ),
				"group" => esc_html__('Background Extras', 'you')
			),		
			array(
				"type" => "checkbox",
				"class" => "",
				"heading" => esc_html__("Slider Black & White Images", 'you'),
				"param_name" => "slider_imgeffect",
				"description" => "Apply black & white effect to images.",
				"value" => array(
					'Enable' => 'enable',
				),
				"group" => esc_html__('Background Extras', 'you')
			),							
			array(
				"type" => "textfield",
				"heading" => esc_html__("Slider Timeout", 'you'),
				"param_name" => "slider_timeout",
				"value" => "",
				"description" => esc_html__("Add timeout in seconds.", 'you'),
				"group" => esc_html__('Background Extras', 'you')
			),						
			array(
				"type" => "textfield",
				"heading" => esc_html__("Video URL", 'you'),
				"param_name" => "bg_video",
				"value" => "",
				"description" => "Add a video to the row background.",
				"group" => esc_html__('Background Extras', 'you')
			),									 
			array(
				"type" => "colorpicker",
				"heading" => esc_html__("Overlay Color", 'you'),
				"param_name" => "overlay_color",
				"value" => "",
				"description" => esc_html__( 'Set an overlay color for Image or Video background.', 'you' ),
				"group" => esc_html__('Background Extras', 'you')
			),	
			array(
				"type" => "checkbox",
				"class" => "",
				"heading" => esc_html__("Inherit Skin Shaded Background Color", 'you'),
				"param_name" => "inherit_shaded_color",
				"description" => esc_html__( 'Inherit the Shaded background color set in the skin options.', 'you' ),
				"value" => array(
					'Enable' => 'enable',
				),
				"group" => esc_html__('Background Extras', 'you')
			),										 											
		  ),	
		  	  
		  "js_view" => 'VcRowView'
		) );	
				
	
		/* Single image */
		vc_map( array(
			'name' => esc_html__( 'Single Image', 'you' ),
			'base' => 'vc_single_image',
			'icon' => 'icon-wpb-single-image',
			'category' => esc_html__( 'Content', 'you' ),
			'description' => esc_html__( 'Simple image with CSS animation', 'you' ),
			'params' => array(
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Image source', 'you' ),
					'param_name' => 'source',
					'value' => array(
						esc_html__( 'Media library', 'you' ) => 'media_library',
						esc_html__( 'External link', 'you' ) => 'external_link',
						esc_html__( 'Featured Image', 'you' ) => 'featured_image'
					),
					'std' => 'media_library',
					'description' => esc_html__( 'Select image source.', 'you' )
				),
				array(
					'type' => 'attach_image',
					'heading' => esc_html__( 'Image', 'you' ),
					'param_name' => 'image',
					'value' => '',
					'description' => esc_html__( 'Select image from media library.', 'you' ),
					'dependency' => array(
						'element' => 'source',
						'value' => 'media_library'
					),
				),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'External link', 'you' ),
					'param_name' => 'custom_src',
					'description' => esc_html__( 'Select external link.', 'you' ),
					'dependency' => array(
						'element' => 'source',
						'value' => 'external_link'
					),
				),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Image size', 'you' ),
					'param_name' => 'img_size',
					'value' => 'thumbnail',
					'description' => esc_html__( 'Enter image size (Example: "thumbnail", "medium", "large", "full" or other sizes defined by theme). Alternatively enter size in pixels (Example: 200x100 (Width x Height)).', 'you' ),
					'dependency' => array(
						'element' => 'source',
						'value' => array( 'media_library', 'featured_image' )
					),
				),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Image size', 'you' ),
					'param_name' => 'external_img_size',
					'value' => '',
					'description' => esc_html__( 'Enter image size in pixels. Example: 200x100 (Width x Height).', 'you' ),
					'dependency' => array(
						'element' => 'source',
						'value' => 'external_link'
					),
				),			
				array(
					"type" => "dropdown",
					"heading" => esc_html__("Caption", 'you'),
					"param_name" => "add_caption",
					"value" => array( 
						esc_html__("None", 'you') => '',
						esc_html__("Media Library Description", 'you') => 'yes',
						esc_html__("Custom", 'you') => 'custom',
					),					
					"description" => esc_html__("Set a Caption using the Media Library Description field or a Custom one.", 'you')
				),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Title', 'you' ),
					'param_name' => 'title',
					'description' => esc_html__( 'Enter text for image title.', 'you' ),
					'dependency' => array(
						'element' => 'add_caption',
						'value' => 'custom'
					),
				),					
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Caption', 'you' ),
					'param_name' => 'caption',
					'description' => esc_html__( 'Enter text for image caption.', 'you' ),
					'dependency' => array(
						'element' => 'add_caption',
						'value' => 'custom'
					),
				),				
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Title Size', 'you' ),
					'param_name' => 'title_size',
					"value" => array( 
						esc_html__("Normal", 'you') => '',
						esc_html__("Small", 'you') => 'small',
						esc_html__("Medium", 'you') => 'medium',
						esc_html__("Large", 'you') => 'large',
					),					
					"dependency" => Array('element' => "add_caption", 'not_empty' => true),
					"description" => esc_html__("Set the Caption Title size.", 'you')
				),					
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Image alignment', 'you' ),
					'param_name' => 'alignment',
					'value' => array(
						esc_html__( 'Left', 'you' ) => 'left',
						esc_html__( 'Right', 'you' ) => 'right',
						esc_html__( 'Center', 'you' ) => 'center'
					),
					'description' => esc_html__( 'Select image alignment.', 'you' )
				),
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Image style', 'you' ),
					'param_name' => 'style',
					'value' => $all_box_styles,
					'description' => esc_html__( 'Select image display style.', 'you' ),
					'dependency' => array(
						'element' => 'source',
						'value' => array( 'media_library', 'featured_image' )
					),
				),
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Image style', 'you' ),
					'param_name' => 'external_style',
					'value' => $box_styles,
					'description' => esc_html__( 'Select image display style.', 'you' ),
					'dependency' => array(
						'element' => 'source',
						'value' => 'external_link'
					),
				),
				array(
					"type" => "dropdown",
					"heading" => esc_html__("On hover Effect", 'you'),
					"param_name" => "hover_effect_circle",
					"value" => array( 
						esc_html__("Select Effect", 'you') => '',
						esc_html__("Fade + Slide Text ( From Bottom ) + Animate Text", 'you') => 'effect13 bottom_to_top'	,
						esc_html__("Fade + Slide Text ( From Left ) + Animate Text", 'you') => 'effect13 from_left_and_right'	,
						esc_html__("Spin + Slide", 'you') => 'effect2 left_to_right',
						esc_html__("Slide + Shrink", 'you') => 'effect3 left_to_right',
						esc_html__("Slide + Fade", 'you') => 'circle effect4 top_to_bottom',
						esc_html__("Roll Right + Fade", 'you') => 'effect9 left_to_right',
						esc_html__("Spin + Fade", 'you') => 'effect11 bottom_to_top',
						esc_html__("Fade + Fold Down", 'you') => 'effect14 top_to_bottom'	,
						esc_html__("Flip Image Top", 'you') => 'effect18 bottom_to_top',
						esc_html__("Flip Image Down", 'you') => 'effect18 top_to_bottom',
						esc_html__("Flip Image Left", 'you') => 'effect18 right_to_left',
						esc_html__("Flip Image Right", 'you') => 'effect18 left_to_right',
	
					),
					"description" => esc_html__("Select hover effect - requires a title or caption.", 'you'),
					'dependency' => array(
						'element' => 'style',
						'value' => array( 'vc_box_circle_2', 'vc_box_border_circle_2', 'vc_box_outline_circle_2', 'vc_box_shadow_circle_2', 'vc_box_shadow_border_circle_2' )
					),					
				),				
				array(
					"type" => "dropdown",
					"heading" => esc_html__("On hover Effect", 'you'),
					"param_name" => "hover_effect_square",
					"value" => array( 
						esc_html__("Select Effect", 'you') => '',
						esc_html__("Zoom Image + Slide Text ( From Top )", 'you') => 'effect6 from_top_and_bottom',
						esc_html__("Zoom Image + Slide Text ( From Left )", 'you') => 'effect6 from_left_and_right',
						esc_html__("Zoom Image + Text", 'you') => 'effect7'	,					
						esc_html__("Flip Image Top", 'you') => 'effect9 bottom_to_top',
						esc_html__("Flip Image Bottom", 'you') => 'effect9 top_to_bottom',
						esc_html__("Flip Image Left", 'you') => 'effect9 right_to_left',
						esc_html__("Flip Image Right", 'you') => 'effect9 left_to_right',
						esc_html__("Slide Image + Text", 'you') => 'effect10 right_to_left',
						esc_html__("3d Rotate Vertical", 'you') => 'effect15 bottom_to_top'	,
						esc_html__("3d Rotate Horizontal", 'you') => 'effect15 right_to_left',
					),
					"description" => esc_html__("Select hover effect - requires a title or caption.", 'you'),
					'dependency' => array(
						'element' => 'style',
						'value' => array( '', 'vc_box_rounded', 'vc_box_rounded', 'vc_box_border', 'vc_box_outline', 'vc_box_shadow', 'vc_box_shadow_border', 'vc_box_shadow_3d', 'vc_box_circle', 'vc_box_border_circle', 'vc_box_outline_circle', 'vc_box_shadow_circle', 'vc_box_shadow_border_circle' )
					),		
				),				
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'On click action', 'you' ),
					'param_name' => 'onclick',
					'value' => array(
						esc_html__( 'None', 'you' ) => '',
						esc_html__( 'Link to Large Image', 'you' ) => 'img_link_large',
						esc_html__( 'Custom Link', 'you' ) => 'custom_link',
					),
					'description' => esc_html__( 'Select action for click action.', 'you' ),
					'std' => ''
				),			
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Custom URL', 'you' ),
					'param_name' => 'link',
					'description' => esc_html__( 'Enter URL if you want this image to have a link (Note: parameters like "mailto:" are also accepted).', 'you' ),
					'dependency' => array(
						'element' => 'onclick',
						'value' => 'custom_link',
					)
				),
				array(
					"type" => "checkbox",
					"class" => "",
					"heading" => esc_html__("Enable Lightbox", 'you'),
					"param_name" => "lightbox",
					'description' => esc_html__( 'Open Large Image in Lightbox or use Lightbox Media URL to open alternative Media.', 'you' ),
					"value" =>  array(
						esc_html__('Enable', 'you') => "enable", 
					)
				),					
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Lightbox Media URL', 'you' ),
					'param_name' => 'media_url',
					'description' => esc_html__( 'Enter Media URL e.g. YouTube URL.', 'you' ),
					'dependency' => array(
						'element' => 'lightbox',
						'value' => 'enable',
					)
				),				
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Link Target', 'you' ),
					'param_name' => 'img_link_target',
					'value' => $target_arr,
					'dependency' => array(
						'element' => 'onclick',
						'value' => array( 'custom_link', 'img_link_large' ),
					),
				),
				$add_css_animation,
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Extra class name', 'you' ),
					'param_name' => 'el_class',
					'description' => esc_html__( 'Style particular content element differently - add a class name and refer to it in custom CSS.', 'you' )
				),
				array(
					'type' => 'css_editor',
					'heading' => esc_html__( 'CSS box', 'you' ),
					'param_name' => 'css',
					'group' => esc_html__( 'Design Options', 'you' )
				),
				// backward compatibility. since 4.6
				array(
					'type' => 'hidden',
					'param_name' => 'img_link_large'
				)
			)
		) );
	}